// Overeni presnosti programovatelneho zdroje napeti HP E3631A
// by Jaja&Paja (c) y2k. y3k ready:)



#include <utility.h>
#include <ansi_c.h>
#include <gpib.h>

short IAdress[3]={22,5,-1};    

void chyby(char msg[30])
{
  if (ibsta >= 0x08000) {
    printf("%s\n", msg);
    printf("ibsta = %xH\n",ibsta);
    printf("iberr = %d\n",iberr);
    printf("\n\nStiskni Enter");
    getchar();
    EnableLocal(0, IAdress);
    exit(EXIT_FAILURE);
  }  
}

int main(){

char data[255];
float Zdroj[31], VMetr[31], AbsErr[31], RelErr[31], maxRel=0, maxRelNap=0;

float i;
FILE *fw;
int j=0;

  SendIFC(0);
  EnableRemote(0, IAdress);
  
  Send(0, 5, "*idn?", 5, 2);
  chyby("Send status: ");
  Receive(0, 5, data,255, 256);
  chyby("Receive status: ");
  data[ibcnt-1]=0;
  printf("%s\n", data);

  Send(0, 22, "*idn?", 5, 2);
  chyby("Send status: ");
  Receive(0, 22, data,255, 256);
  chyby("Receive status: ");
  data[ibcnt-1]=0;
  printf("%s\n", data);
  
  
  Send(0,5,"inst p6v", 8, 2);
  chyby("Send status: ");
  Send(0,5,"volt 0.0", 8, 2);
  chyby("Send status: ");

  printf("Zadana [V]\tNamerena [V]\tAbs. chyba [mV]\tRel. chyba [%%]\n");  
  
  for (i=0; i<=6; i+=0.2)
	  {
	  
	   sprintf(data, "volt %f",i); 
	   Send(0,5,data, strlen(data), 2);
	   chyby("Send status: "); 
	   sprintf(data, "meas:volt:dc?");
	   Delay(1);
	   Send(0,22,data, strlen(data), 2);
	   chyby("Send status: ");  
	   Receive(0,22,data,255,2);
	   chyby("Receive status: ");  
	   data[ibcnt]=0;
	   
	   Zdroj[j]=i;
	   sscanf (data, "%f", &VMetr[j]);
	   AbsErr[j]= VMetr[j]-i;  
	   
	   if (i!=0) { RelErr[j]= (AbsErr[j]/i)*100; }
	     else {RelErr[j] = 0;}

	   if (RelErr[j] > maxRel) { maxRel = RelErr[j]; maxRelNap = Zdroj[j]; }  
	     
	   printf("%2.3f\t\t%2.6f\t\t%2.3f\t\t\t%2.2f\n",Zdroj[j],VMetr[j],AbsErr[j]*1000,RelErr[j]);	  
	   
	   j++;
	  }
	
	printf("\nMaximalni relativni chyba je %2.2f [%%] pri napeti %2.3f [V]\n", maxRel, maxRelNap);
	 
	if ((fw=fopen("vystup.txt","w"))==NULL) {
	
	  printf("Soubor vystup.txt nelze vytvorit");
	
	} else {
	
	 fprintf(fw, "Zadana [V]\tNamerena [V]\tAbs. chyba [mV]\tRel. chyba [%%]\n");
	 
	 
	 for (j=0; j<=30; j++)
		{
		
		fprintf(fw, "%2.3f\t\t%2.6f\t%2.3f\t\t%2.2f\n",Zdroj[j],VMetr[j],AbsErr[j]*1000,RelErr[j]);
		
		}
	fprintf(fw, "\n\nMaximalni relativni chyba je %2.2f [%%] pri napeti %2.3f [V]\n", maxRel, maxRelNap);	
	
	fclose(fw); 
	
	}
	printf("\nStisknete ENTER");
    getchar();

  EnableLocal(0, IAdress);
  
  }
