#include <cvirte.h>		
#include <userint.h>
#include "deska.h"

static int panelHandle;

//
// udeklat juzr fejs!
//

#include <utility.h>
#include <ansi_c.h>

#define BASE 0x300
#define GainReg BASE + 0x9
#define ModeReg BASE + 0xB
#define MuxReg BASE + 0xA
#define SWTrigReg BASE + 0xC
#define DataLoReg BASE + 0x4
#define DataHiReg BASE + 0x5
//definice pro citac
#define CountNo1 BASE + 0x1
#define CountNo2 BASE + 0x2
#define CW BASE + 0x3

char keypress()
{
  printf("Stiskni ENTER");
  return getchar();
}

union {
   unsigned int dword;
   unsigned char byte[4];
} Frq;

union {
	unsigned short word;
	char byte[2];
} Data;

// msg by paja
//
// karta meri od -5V do +5V
// tj.    0 ~ -5 V
//     2048 ~  0 V
//     4096 ~  5 V
//
// Pokud ctu driv DataHiReg, neni v nem DRDY, nastavi se znova po cteni DataLoReg
//

float Pole[1000];

int activation(float MyFrq) {

    Frq.dword = 2e3 / MyFrq;

	outp(CW, 0x74);
	outp(CW, 0xB4);

	if ((Frq.byte[2] == 0)&&(Frq.byte[3] == 0)) { 
	  Frq.dword=Frq.dword/2;
	  Frq.byte[2] = 1;
	  Frq.byte[3] = 0;
	}  
	
	
	outp(CountNo1, Frq.byte[0]);
	outp(CountNo1, Frq.byte[1]);
	outp(CountNo2, Frq.byte[2]);
	outp(CountNo2, Frq.byte[3]);

	outp(GainReg, 0);
	outp(MuxReg, 0);	
	
	outp(ModeReg, 4);
	
	return 0;
}

int read_data() {
	
int i;	
for (i=0; i<1000; i++) {	
	
	do { Data.byte[1] = inp(DataHiReg); } while ((Data.byte[1] & 0x010)!=0);
	
	Data.byte[0] = inp(DataLoReg);

	Pole[i] = (10.0*Data.word/0x1000)-5.0;
	
//	printf("Data = %X\nVal=%f\n\n", Data.word, Val);

}
 return 0;
}

int CVICALLBACK work (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:

			break;
		}
	return 0;
}

int CVICALLBACK konec (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			QuitUserInterface (0);
			break;
		}
	return 0;
}

int CVICALLBACK run (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
		
{

    float F,Xf;
    
	switch (event)
		{
		case EVENT_COMMIT:
		
		    SetCtrlVal(PANEL, PANEL_LED,1);
		    
		    GetCtrlVal(panel, PANEL_NUMERIC, &F);
		    
			activation(F);
			read_data();
			
			DeleteGraphPlot(PANEL, PANEL_GRAPH, -1, VAL_IMMEDIATE_DRAW);
            
            Xf = 1/F*1000;
            
			PlotWaveform (PANEL, PANEL_GRAPH, &Pole, 1000, VAL_FLOAT, 1, 0, 0,
						  Xf, VAL_THIN_LINE, VAL_CONNECTED_POINTS, VAL_SOLID,
						  VAL_CONNECTED_POINTS, VAL_RED);

			SetCtrlVal(PANEL, PANEL_LED,0);
			
			break;
		}
	return 0;
}

int CVICALLBACK graph (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:

			break;
		}
	return 0;
}


int main(int argc, char *argv[])
{
	float Val;
	int i;

	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((panelHandle = LoadPanel (0, "deska.uir", PANEL)) < 0)
		return -1;
	DisplayPanel (panelHandle);
	RunUserInterface ();

	DiscardPanel (panelHandle);
	return 0;

}

int CVICALLBACK freq (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:

			break;
		}
	return 0;
}
